%% Removes data points from data set that you can locate outside of the bone

% shows scatter plot and enables drawing a polygon. upon finalizing the
% polygon all the data inside the polygon will be deleted from the dataset
first = figure('position', [50, 100, 1800, 1000]);
ac = subplot(2,1,1);
scatter(data2{1,1}(:,2),data2{1,1}(:,1),3,'facecolor','k');
title(['File ' num2str(jj) ' original dataset XY'])
dc = subplot(2,1,2);
scatter(data2{1,1}(:,2),data2{1,1}(:,3),3,'facecolor','k');
title(['File ' num2str(jj) ' original dataset XZ'])

% Dialog and plots to remove more artifacts. Stops when you click NO
plotti = questdlg('Do you want to gate on the XY or XZ plot?','Artifact Removal','XY','XZ','XY');

switch plotti
    case 'XY'
        h = impoly(ac);
        nodes = getPosition(h);
        selected_indices = find(inpolygon(data2{1,1}(:,2),data2{1,1}(:,1), nodes(:,1), nodes(:,2)));
        
        % Dialog and plots to remove more artifacts. Inside or Outside gate
        choiceE = questdlg('Do you want to keep cells inside or outside the gate?','Gate','Inside','Outside','Inside');
        switch choiceE
            case 'Inside'
                data11{1,1} = data1{1,1}(selected_indices(:,1),:);
                inside = 1;
            case 'Outside'
                data1{1,1}(selected_indices(:,1),:) = [];
                inside = 0;
        end
        
        clearvars h nodes selected_indices
    case 'XZ'
        h = impoly(dc);
        nodes = getPosition(h);
        selected_indices = find(inpolygon(data2{1,1}(:,2),data2{1,1}(:,3), nodes(:,1), nodes(:,2)));
        
        % Dialog and plots to remove more artifacts. Inside or Outside gate
        choiceE = questdlg('Do you want to keep cells inside or outside the gate?','Gate','Inside','Outside','Inside');
        switch choiceE
            case 'Inside'
                data11{1,1} = data1{1,1}(selected_indices(:,1),:);
                inside = 1;
            case 'Outside'
                data1{1,1}(selected_indices(:,1),:) = [];
                inside = 0;
        end
     
        clearvars h nodes selected_indices
end
close(first)

if inside == 1;
    % scatter plot of new dataset (inside) to decide wether or not to remove more
    % artifacts
    second = figure('position', [50, 100, 1800, 1000]);
    ac1 = subplot(2,1,1);
    scatter(data11{1,1}(:,2),data11{1,1}(:,1),3,'facecolor','k');
    title(['File ' num2str(jj) ' updated dataset XY'])
    dc1 = subplot(2,1,2);
    scatter(data11{1,1}(:,2),data11{1,1}(:,3),3,'facecolor','k');
    title(['File ' num2str(jj) ' updated dataset XZ'])
    indic = 1;
else
    % scatter plot of new dataset (outside) to decide wether or not to remove more
    % artifacts
    second = figure('position', [50, 100, 1800, 1000]);
    ac1 = subplot(2,1,1);
    scatter(data1{1,1}(:,2),data1{1,1}(:,1),3,'facecolor','k');
    title(['File ' num2str(jj) ' updated dataset XY'])
    dc1 = subplot(2,1,2);
    scatter(data1{1,1}(:,2),data1{1,1}(:,3),3,'facecolor','k');
    title(['File ' num2str(jj) ' updated dataset XZ'])
    indic = 0;
end

            

% Dialog and plots to remove more artifacts. Stops when you click NO
choice = questdlg('Do you want to remove more artifacts?','Artifact Removal','Yes','No & Start','Yes');
close(second)

switch choice
    case 'Yes'
        
  if indic == 1;
      data11 = data11;
  else
      data11 = data1;
  end
  
     for i = 1:100
            clearvars insideI        
            update = figure('position', [50, 100, 1800, 1000]);
            ac2 = subplot(2,1,1);
            scatter(data11{1,1}(:,2),data11{1,1}(:,1),3,'facecolor','k');
            title(['File ' num2str(jj) ' updated dataset XY, Version ' num2str(i)])
            dc2 = subplot(2,1,2);
            scatter(data11{1,1}(:,2),data11{1,1}(:,3),3,'facecolor','k');
            title(['File ' num2str(jj) ' updated dataset XZ, Version ' num2str(i)])

            
            % Dialog and plots to remove XY or XZ artifacts.
            plotti = questdlg('Do you want to gate on the XY or XZ plot?','Artifact Removal','XY','XZ','XY');

            switch plotti
                case 'XY'
                    h = impoly(ac2);
                    nodes = getPosition(h);
                    selected_indices = find(inpolygon(data11{1,1}(:,2),data11{1,1}(:,1), nodes(:,1), nodes(:,2)));
                    
                    % Dialog and plots to remove more artifacts. Inside or Outside gate
                    choiceE = questdlg('Do you want to keep cells inside or outside the gate?','Gate','Inside','Outside','Inside');
                        switch choiceE
                            case 'Inside'
                                data11a{1,1} = data11{1,1}(selected_indices(:,1),:);
                                insideI = 1;
                            case 'Outside'
                                data11{1,1}(selected_indices(:,1),:) = [];
                                insideI = 0;
                        end
                    clearvars h nodes selected_indices
                    
                case 'XZ'
                    h = impoly(dc2);
                    nodes = getPosition(h);
                    selected_indices = find(inpolygon(data11{1,1}(:,2),data11{1,1}(:,3), nodes(:,1), nodes(:,2)));
                    
                    % Dialog and plots to remove more artifacts. Inside or Outside gate
                    choiceE = questdlg('Do you want to keep cells inside or outside the gate?','Gate','Inside','Outside','Inside');
                        switch choiceE
                            case 'Inside'
                                data11a{1,1} = data11{1,1}(selected_indices(:,1),:);
                                insideI = 1;
                            case 'Outside'
                                data11{1,1}(selected_indices(:,1),:) = [];
                                insideI = 0;
                        end
                    clearvars h nodes selected_indices
            end
            
        if insideI == 1;    
            third = figure('position', [50, 100, 1800, 1000]);
        subplot(2,1,1);
        scatter(data11a{1,1}(:,2),data11a{1,1}(:,1),3,'facecolor','k');
        title(['File ' num2str(jj) ' updated dataset XY, Version ' num2str(i+1)])
        subplot(2,1,2);
        scatter(data11a{1,1}(:,2),data11a{1,1}(:,3),3,'facecolor','k');
        title(['File ' num2str(jj) ' updated dataset XZ, Version ' num2str(i+1)])
        
        else
            third = figure('position', [50, 100, 1800, 1000]);
        subplot(2,1,1);
        scatter(data11{1,1}(:,2),data11{1,1}(:,1),3,'facecolor','k');
        title(['File ' num2str(jj) ' updated dataset XY, Version ' num2str(i+1)])
        subplot(2,1,2);
        scatter(data11{1,1}(:,2),data11{1,1}(:,3),3,'facecolor','k');
        title(['File ' num2str(jj) ' updated dataset XZ, Version ' num2str(i+1)])
        end
        
            choice1 = questdlg('Do you want to remove more artifacts?','Artifact Removal','Yes','No & Start','Yes');
            u = strcmp(choice1,'Yes');
            if u == 1
               close(update)
               close(third)
               
               if insideI == 1
                   data11 = data11a;
               else
                   data11 = data11;
               end
               
            else
               close(update)
               close(third)
               
               if insideI == 1
                   data3{1,1}.data = data11a;
               else
                   data3{1,1}.data = data11;
               end
               
               break
            end
        end
        
    case 'No & Start'
        
        if  indic == 1
        data3{1,1}.data = data11;
        else
        data3{1,1}.data = data1;
        end
        
end