%% Allows spatial splitting of the dataset

% shows scatter plot and enables drawing multiple polygons. The regions
% inside the polygons can be saved as new workspaces
first = figure('position', [50, 100, 1800, 1000]);
ac = subplot(2,1,1);
scatter(data2{1,1}(:,2),data2{1,1}(:,1),3,'facecolor','k');
title(['File ' num2str(jj) ' original dataset XY'])
dc = subplot(2,1,2);
scatter(data2{1,1}(:,2),data2{1,1}(:,3),3,'facecolor','k');
title(['File ' num2str(jj) ' original dataset XZ'])

plotti = questdlg('Do you want to split based on the XY or XZ plot?','Split dataset','XY','XZ','XY');
howmany = inputdlg('How many regions do you want to define?','Split dataset');
a = str2double(howmany{1,1});
data11 = cell(1,a);
switch plotti
	case 'XY'
        for i = 1:a
            h = impoly(ac);
            nodes = getPosition(h);
            selected_indices = find(inpolygon(data2{1,1}(:,2),data2{1,1}(:,1), nodes(:,1), nodes(:,2)));
            data11{1,i} = data1{1,1}(selected_indices(:,1),:);
            clearvars h nodes selected_indices
        end
    case 'XZ'
        for i = 1:a
            h = impoly(dc);
            nodes = getPosition(h);
            selected_indices = find(inpolygon(data2{1,1}(:,2),data2{1,1}(:,3), nodes(:,1), nodes(:,2)));
            data11{1,i} = data1{1,1}(selected_indices(:,1),:);
            clearvars h nodes selected_indices
        end
end
close(first)

Namesses = get(handles.gatebox,'string');
vali = get(handles.gatebox,'value');

for i = 1:a
    stats = data11{1,i};
    
    % if the data is transformed dont do it again, otherwise do it and thus
    % create a parentpop that is transformed
    r = handles.gatinghist;
    BiExID = r{6,get(handles.gatebox,'value')};
    if BiExID == 1
        state.BiEx_StatsMatrix  = stats;
    else
        state.BiEx_StatsMatrix  = asinh(stats);
    end

    % get the position of the gating box (current gate) and set this as the
    % parent gate
    gateboxvalue = get(handles.gatebox,'Value');
    gatinghist = handles.gatinghist; 
    currentgate = gatinghist(:,gateboxvalue);
    gatinghistNew = cell(7,100);
    gatinghistNew(:,1) = currentgate;
    gatinghistNew(1,1) = {stats};
    state.gatinghist = gatinghistNew;                   %gating history data
    state.gateboxtext = {'Parent population'; '...'};  %gating history text
    state.gateboxvalue = 1;  %gating history position
    
    %gatehist = handles.gatinghist;   
    %Names = get(handles.gatebox,'string');
    %for j = 1:length(Names)
    %    if strcmp(Names{j,1},'...')
    %        Val = j;
    %        break
    %    end
    %end 
    %gatehist{1,Val} = stats;
    %gatehist{2,Val} = ind_a;
    %gatehist{3,Val} = ind_b;
    %f = get(handles.uipanel1,'SelectedObject');
    %Sel = get(f,'String');
    %gatehist{4,Val} = Sel;
    %asinhIDX = get(handles.asinhX,'Value');
    %asinhIDY = get(handles.asinhY,'Value');
    %asinhIDen = handles.BiExID;
    %if asinhIDen == 1 & (asinhIDX == 1 & asinhIDY == 0) 
    %    gatehist{5,Val} = 1;
    %elseif asinhIDen == 1 & (asinhIDX == 0 & asinhIDY == 1)
    %    gatehist{5,Val} = 2;
    %elseif asinhIDen == 1 & (asinhIDX == 1 & asinhIDY == 1) 
    %    gatehist{5,Val} = 3;
    %elseif asinhIDen == 0
    %    gatehist{5,Val} = 0;    
    %end
    %gatehist{6,Val} = asinhIDen;

    %Names{Val,1} = 'Spatial Gate';
    %Names{Val+1,1} = '...';
    %set(handles.gatebox,'Value',Val);
    %set(handles.gatebox,'String',Names);
    state.colasinh = get(handles.colasinh,'value');
    state.cofact_col = get(handles.cofact_col,'String');
    state.cofactor = get(handles.cofactor,'String');
    state.ParentXYZs = handles.ParentXYZs;
    state.asinhX = get(handles.asinhX,'Value');
    state.asinhY = get(handles.asinhY,'Value');
    state.linX = get(handles.linX,'Value');
    state.linY = get(handles.linY,'Value');
    state.enlinX = get(handles.linX,'Enable');
    state.enlinY = get(handles.linY,'Enable');
    state.enasinhX = get(handles.asinhX,'Enable');
    state.enasinhY = get(handles.asinhY,'Enable');
    state.BiExBtn = get(handles.BiExBtn,'Enable');
    state.LinBtn = get(handles.LinBtn,'Enable');
    state.Sel = get(handles.uipanel1,'SelectedObject');
    %state.gatinghist = gatehist;
    %state.gateboxtext = get(handles.gatebox,'String');
    %state.gateboxvalue = get(handles.gatebox,'Value');
    state.sizeSc = handles.sizeSc;
    state.aritID = handles.aritID;
    %state.aritstats = handles.aritstats;
    state.aritstats = stats;
    state.kmCol = handles.kmCol;
    state.StatNames = handles.StatNames;
    state.popupSizeVal = get(handles.popupSize,'Value');
    state.popupSizeString = get(handles.popupSize,'String');
    state.popupColVal = get(handles.popupCol,'Value');
    state.popupColStr = get(handles.popupCol,'String');
    state.textXax = get(handles.textXax,'string');
    state.textYax = get(handles.textYax,'string');
    state.popupXst = get(handles.popupX,'string');
    state.popupYst = get(handles.popupY,'string');
    %state.Imaris = get(handles.Imaris,'value');
    %state.LTformat = get(handles.LTformat,'value');
    %state.scatterplot = get(handles.scatterplot,'value');
    %state.histplot = get(handles.histplot,'value');
    state.popupYval = get(handles.popupY,'Value');
    state.popupXval = get(handles.popupX,'Value');
    state.hist_bins = get(handles.hist_bins,'String');
    state.Ymin = get(handles.Ymin,'String');
    state.Ymax = get(handles.Ymax,'String');
    state.Xmin = get(handles.Xmin,'String');
    state.Xmax = get(handles.Xmax,'String');
    state.Gate_Y = get(handles.Gate_Y,'String');
    state.Gate_X = get(handles.Gate_X,'String');
    state.Gate_Yperc = get(handles.Gate_Yperc,'String');
    state.Gate_Xperc = get(handles.Gate_Xperc,'String');
    %state.GatingTable = get(handles.GatingTable,'Data');
    state.GatingTable = [];
    state.radminus = get(handles.radminus,'Value');
    state.radmultiply = get(handles.radmultiply,'Value');
    state.raddivide = get(handles.raddivide,'Value');
    state.plusrad = get(handles.plusrad,'Value');
    state.popupAStr = get(handles.popupA,'string');
    state.popupBStr = get(handles.popupB,'string');
    state.popupAVal = get(handles.popupA,'value');
    state.popupBVal = get(handles.popupB,'value');
    state.StaAfact = get(handles.StaAfact,'string');
    state.StaBfact = get(handles.StaBfact,'string');
    state.BiExID = handles.BiExID;
    state.percQ1 = handles.percQ1;
    state.percQ2 = handles.percQ2;
    state.percQ3 = handles.percQ3;
    state.percQ4 = handles.percQ4;
    state.numQ1 = handles.numQ1;
    state.numQ2 = handles.numQ2;
    state.numQ3 = handles.numQ3;
    state.numQ4 = handles.numQ4;
    state.percbelowX = handles.percbelowX;
    state.percaboveX = handles.percaboveX;
    state.numbelowX = handles.numbelowX;
    state.numaboveX = handles.numaboveX;
    state.percbelowY = handles.percbelowY;
    state.percaboveY = handles.percaboveY;
    state.numbelowY = handles.numbelowY;
    state.numaboveY = handles.numaboveY;
    state.percofallQ1 = handles.percofallQ1;
    state.percofallQ2 = handles.percofallQ2;
    state.percofallQ3 = handles.percofallQ3;
    state.percofallQ4 = handles.percofallQ4;
    state.percofallaX = handles.percofallaX;
    state.percofallbX = handles.percofallbX;
    state.percofallaY = handles.percofallaX;
    state.percofallbY = handles.percofallbX;
    state.names = Names_of_stats;
    state.stats = stats;
    state.statsCl  = stats; 
    state.statsClear  = stats;
    state.namesCl  = Names_of_stats;
    state.NamesforExp  = handles.NamesforExp;
    state.StatNames = Names_of_stats;
    %state.names  = handles.names;
    %state.stats  = stats;
    %state.BiEx_StatsMatrix  = handles.BiEx_StatsMatrix;
    %state.statsCl  = handles.statsCl; % the pop defined in workspace (spatial gating etc) is parent. only clear all brings it back
    %state.statsClear  = handles.statsClear;
    %state.namesCl  = handles.namesCl;
    state.inda  = handles.inda;
    state.indb  = handles.indb;
    state.indexAa  = handles.indexAa;
    state.indexAb  = handles.indexAb;
    state.NamesforExp  = handles.NamesforExp;
   	state.histo  = handles.histo;
    state.line  = handles.line;
    state.fillarea  = handles.fillarea;
    state.axes1 = handles.axes1;
    state.lineplot = handles.lineplot;
    state.histplot = handles.histplot;
    state.fillplot = handles.fillplot;
    state.nodes = handles.nodes;
    pathname = handles.savepath;
    saveID = handles.saveID;

    if saveID == 1
        [FileNameWS,~] = uiputfile('*.mat','Save workspace',pathname);
        FileNameWS2 = fullfile(pathname, FileNameWS);
        save(FileNameWS2,'state');
    else    
        if exist('PathNameWS')
            [FileNameWS,~] = uiputfile('*.mat','Save workspace',PathNameWS);
            FileNameWS2 = fullfile(PathNameWS, FileNameWS);
            save(FileNameWS2,'state');
        else
            [FileNameWS,PathNameWS] = uiputfile('*.mat','Save workspace');
            FileNameWS2 = fullfile(PathNameWS, FileNameWS);
            save(FileNameWS2,'state');
        end
    end
    clearvars stats FileNameWS2 FileNameWS state
    set(handles.gatebox,'string',Namesses);
end
set(handles.gatebox,'string',Namesses);
set(handles.gatebox,'value',vali);
waitfor(msgbox('Export successful!'));